/*
 * Gnophone: A client for the Asterisk PBX
 *
 * Copyright (C) 2000, Linux Support Services, Inc.
 *
 * Written by Mark Spencer
 *
 * Linux/UNIX version distributed under the terms of
 * the GNU General Public License
 *
 * html-xmhtml.c GTK Xm-HTML based browser back-end
 *
 */

#include <stdio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>                                                   
#include <string.h>

#include <gtk/gtk.h>
#include <gtk-xmhtml/gtk-xmhtml.h>
#include <ghttp.h>

#include "gnophone.h"
#include "htmlengine.h"

struct html_pvt {
	GtkWidget *xmh;
	ghttp_request *req;
	char *uri;
};

static GtkWidget *xmh_new_engine(struct browser *b)
{
	GtkWidget *w;
	struct html_pvt *p = g_new(struct html_pvt, 1);
	w = gtk_xmhtml_new();
	p->xmh = w;
	b->pvt = p;
	return w;
}

static int xmh_can_go_forward(struct browser *b)
{
	return 1;
}

static int xmh_can_go_back(struct browser *b)
{
	return 1;
}

static void xmh_go_back(struct browser *b)
{
}

static void xmh_go_forward(struct browser *b)
{
}

static void xmh_reload(struct browser *b, int force)
{
}

static void xmh_loadurl(struct browser *b, char *uri)
{
	printf("Loading URL %s\n", uri);
	if (b->pvt->req)
		ghttp_request_Destroy(b->pvt->req);
	b->pvt->req = ghttp_request_new();
	if (ghttp_set_uri(b->pvt->req, uri)) {
		fprintf(stderr, "Unable to load URI '%s'\n", uri);
	if (b->pvt->uri)
		free(b->pvt->uri);
	b->pvt->uri = g_strdup(uri);
	ghttp_set_sync(b->pvt->req, ghttp_async
	
}

static void xmh_stop(struct browser *b)
{
}

static struct html_engine xmhtml;

char *key() 
{
	return KEY;
}

char *name()
{
	return "xmhtml";
}

int init()
{
	strcpy(xmhtml.name, "xmhtml");
	xmhtml.new_engine = xmh_new_engine;
	xmhtml.can_go_back = xmh_can_go_back;
	xmhtml.can_go_forward = xmh_can_go_forward;
	xmhtml.go_back = xmh_go_back;
	xmhtml.go_forward = xmh_go_forward;
	xmhtml.reload = xmh_reload;
	xmhtml.loadurl = xmh_loadurl;
	xmhtml.stop = xmh_stop;
	xmhtml.next = NULL;
	html_register_engine(&xmhtml);
	return 0;
}

